#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateCommand = void 0;
const commander_1 = require("commander");
const CreateCommandAction_1 = require("./CreateCommandAction");
const commands_1 = require("../../../core/commands");
exports.CreateCommand = new commander_1.Command('create')
    .arguments('<source> <destination>')
    .description('Creates a file or folder based on the <source> at <destination>')
    .option('-n, --name <name>', 'Changes the name of a file or folder', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.name)
    .option('-t, --templates-folder <path>', 'Path to templates folder', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.templatesFolder)
    .option('-e, --encoding <encoding>', 'Changes the content encoding of the read files', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.encoding)
    .option('-rn, --replace-names <names...>', 'Replaces the names of a file or folder', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.replaceNames)
    .option('-nb, --no-brackets', 'Makes brackets not required when using the --replace-names option', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.brackets)
    .option('-rc, --replace-content <content...>', 'Replaces parts of the contents of a file or files within a folder', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.replaceContent)
    .option('-kvs, --key-value-separator <separator>', 'Defines a custom key-value separator', commands_1.CREATE_COMMAND_DEFAULT_OPTIONS.keyValueSeparator)
    .action(CreateCommandAction_1.createCommandAction);
