"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleErrors = void 0;
const chalk_1 = __importDefault(require("chalk"));
const errors_1 = require("../../core/errors");
const handleErrors = (error) => {
    if (error instanceof errors_1.SyntaxError) {
        const syntaxError = error;
        console.log(chalk_1.default.red(syntaxError.message));
        console.log();
        console.log(chalk_1.default.green('Expected:'));
        console.log(chalk_1.default.green(syntaxError.expected));
        console.log();
        console.log(chalk_1.default.redBright('Received:'));
        console.log(chalk_1.default.redBright(syntaxError.received));
    }
    else if (error instanceof errors_1.NotFoundError) {
        const notFoundError = error;
        console.log(chalk_1.default.red(notFoundError.message));
    }
    else if (error instanceof errors_1.AlreadyExistsError) {
        const alreadyExistsError = error;
        console.log(chalk_1.default.red(alreadyExistsError.message));
    }
    else if (error instanceof errors_1.MisusedOptionsError) {
        const misusedOptionsError = error;
        console.log(chalk_1.default.red(misusedOptionsError.message));
    }
    else {
        console.log(chalk_1.default.red(error.message));
    }
};
exports.handleErrors = handleErrors;
