"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceTextPieces = exports.escapeRegex = void 0;
const escapeRegex = (str) => {
    return str.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
};
exports.escapeRegex = escapeRegex;
const replaceTextPieces = (text, pieces) => {
    const escapedPieces = Object.keys(pieces).map((piece) => exports.escapeRegex(piece));
    const pattern = escapedPieces.join('|');
    const regex = new RegExp(pattern, 'g');
    return text.replace(regex, (matched) => pieces[matched]);
};
exports.replaceTextPieces = replaceTextPieces;
